<template>
  <el-card header="经营数据">
    <statistic :col="5" class="statistic" :cols="0">
      <statistic-item v-for="(item, key) in items" :key="key" :class="{active: active === key}" @click="active = key">
        <span>
          {{item.title}}
          <el-tooltip v-if="item.desc" :content="item.desc" :open-delay=".3" placement="top">
            <i style="margin-left: 5px;cursor: pointer;" class="el-icon-warning-outline"/>
          </el-tooltip>
        </span>
        <span>
          <count-to :endVal="item.percent" :decimals="2"/>
        </span>
      </statistic-item>
    </statistic>
    <ve-line :settings="{
        area: true,
      }"
      :data="chartData"
      height="350px"
      :data-empty="dataEmpty"
      :data-zoom="dataZoom"
      :extend="chartExtend"
    />
  </el-card>
</template>
<script>
import 'echarts/lib/component/dataZoom'
import countTo from 'vue-count-to'
import veLine from 'v-charts/lib/line.common'
export default {
  props: ['data'],
  components: {
    've-line': veLine,
    'count-to': countTo
  },
  computed: {
    items() {
      return {
        FINANCE_AMOUNT: this.data['FINANCE_AMOUNT'] || {},
        FINANCE_BALANCE_AMOUNT: this.data['FINANCE_BALANCE_AMOUNT'] || {},
        FINANCE_PAY: this.data['FINANCE_PAY'] || {},
      }
    },
    chartExtend() {
      return {
        tooltip: {
          formatter: item => {
            return [item[0].axisValueLabel, ...item.map(d => {
              return `<br/>${d.marker}${d.seriesName}: ${this.$helpers.numeral(d.value[1]).format('0,0.00')}`
            })].join('')
          }
        }
      }
    },
    dataZoom() {
      return [
        {
          type: 'slider',
          start: 50,
          end: 100
        }
      ]
    },
    chartData() {
      const values = Object.values(this.items)
      const months = {}
      for (const item of values) {
        for (const row of (item.indexMonthData || [])) {
          const key = this.$helpers.dayjs(row.month).format('YYYY-MM-DD')
          if (!months[key]) {
            months[key] = {
              '日期': key,
            }
          }
          months[key][item.title] = row.percent
        }
      }
      return {
        columns: ['日期', ...values.map(item => item.title)],
        rows: Object.values(months)
      }
    },
    dataEmpty() {
      return !this.chartData.rows.length
    },
  },
  data () {
    return {
      active: 'SHOULD_INCOME_MONEY',
    }
  },
}
</script>
<style lang="less" scoped>
  // .statistic{
  //   /deep/ .statistic-content{
  //     cursor: pointer;
  //     &.active > span{
  //       color: #14928a !important;
  //     }
  //   }
  // }
</style>
